"
 COPYRIGHT (c) 1989 by Claus Gittinger
	      All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"

Object subclass:#Workstation
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Interface-Graphics'
!

!Workstation class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 1989 by Claus Gittinger
	      All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
!

documentation
"
    this class is only here, to get an instance of XWorkstation
    named Display - this cannot be done in XWorkstation since Display
    is defined in X.h/Xlib.h -- sigh

    [author:]
        Claus Gittinger
"
! !

!Workstation class methodsFor:'initialization'!

initialize
    |wsClass workstationType|

    "
     initialize the default display - this must be done only once
    "
    Display isNil ifTrue:[
        "
         figure out, which display class to use
         (if multiple have been bound into the system)
        "

        "
         if there is a GL-XWorkstation, use it
        "
        (wsClass := Smalltalk at:#OpenGLWorkstation) notNil ifTrue:[
	    workstationType := wsClass.
	] ifFalse:[
            (wsClass := Smalltalk at:#GLXWorkstation) notNil ifTrue:[
                workstationType := wsClass.
            ] ifFalse:[
                workstationType := XWorkstation
	    ]
        ].

        workstationType notNil ifTrue:[
            "
             make sure its initialized ...
            "
            workstationType initialize.
        ].

        "
         preparation for NeXTStep interfacing;
         (but if X is linked in, this will be our default Display
          this will change later)
        "
        (wsClass := Smalltalk at:#NeXTWorkstation) notNil ifTrue:[
            wsClass initialize.

            workstationType isNil ifTrue:[
                workstationType := wsClass
            ]
        ].

        "
         preparation for OS2 interfacing;
         (but if X is linked in, this will be our default Display
          this will change later ...)
        "
        (wsClass := Smalltalk at:#OS2Workstation) notNil ifTrue:[
            wsClass initialize.

            workstationType isNil ifTrue:[
                workstationType := wsClass
            ]
        ].

        "
         preparation for Win32 interfacing;
         (but if X is linked in, this will be our default Display)
          this will change later ...)
        "
        (wsClass := Smalltalk at:#WinWorkstation) notNil ifTrue:[
            wsClass initialize.

            workstationType isNil ifTrue:[
                workstationType := wsClass
            ]
        ].

        workstationType notNil ifTrue:[
            Display isNil ifTrue:[
                Display := workstationType basicNew initializeFor:nil.
            ]
        ] ifFalse:[
            'WORKSTATION: no concrete Display class built in' infoPrintNL.
        ].

        "
         if we found any display, make it the default.
        "
        Display notNil ifTrue:[
            DeviceWorkstation default:Display.
            DisplayRootView initialize.
            Screen := Display class.
        ]
    ]

    "Modified: 8.3.1996 / 19:56:03 / cg"
!

reinitialize
    "reinitialize after a snapin."

    "
     this code will eventually handle the case where we come up
     on another type of workstation. For now, images save while running
     on X will not work properlly on some other device
    "
    Display notNil ifTrue:[
	Display reinitialize.
    ]
! !

!Workstation class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/libview/Attic/Workstation.st,v 1.22 1996-12-13 18:01:16 cg Exp $'
! !
Workstation initialize!
